<template>
	<div class="print_grid_style">
		<el-main>
			<div class="flex-content just-center mt-90 mb-20">
				<h1 class="text-blue-color">Programación de la {{dateString}}</h1>
			</div>
			<!-- lateral schedule -->
			<div class="flex-content" style="justify-content: center;">
				<div>
					<div class="grid-schedule-title box_style_border_left width-50" ref="scrollSchedule">
						<div style="height: 31px"></div>
					</div>

					<div class="box_style box_style_border_left">
						<div style="grid-row:1/4" class="grid-schedule resize o-hidden">
							<p class="font-i-16"> 05:16 </p>
						</div>
						<div class="grid-schedule resize flex-content justify-content-center font-i-12" 
						v-for="(time, index) in timeForDay" :key="index" 
						:style="`grid-area: ${(6*  index) +4} / 1/ span 6 / 2`">
							<p class="font-i-16">{{ time }}</p>
						</div>
						<div class="grid-schedule resize o-hidden border-none" style="grid-row:286/289">
							<p class="font-i-16"> 05:00 </p>
				 		</div>
					</div>

					<div class="grid-schedule-title box_style_border_left">
						<div style="height: 31px"></div>
					</div>
				</div>

				<!--Content-->
				<div>
					<gridDays :days="generateDays()" :sizeLetters="'font-i-18 d-flex flex-content justify-content-center'" :space="'pl-5'"/>

					<div class="grid-programs" ref="contenedor">
						<div v-for="(program, index) in orderByProgram" :key="index" class="grid-byProgram" :ref="`cell-${index}`"  :class="[styleByDurationProgram(program.programPrincipal)]">
							<div class="work-break box_title" :class="[durationProgramResize(program.programPrincipal)]">
								<div :class="[ program.programPrincipal.stringMaterialType == 'Producción Nacional'? 'text-orange principalTitle' : 'text-blue-color principalTitle', styleTitlePrincipal(program.programByDay)]" v-if="!isLargometraje(program.programPrincipal.typeOfContent)">{{ program.programPrincipal.programTitle }}
									<!-- _________ Clasificación __________ -->
								<span  v-if="program.programPrincipal.classification && program.programPrincipal.classification !== ''" :class="[isClassificationFilmsShow(program.programPrincipal)]"  class="pl-5" :style="{color: program.programPrincipal.clasificationColor}">{{ isHaveContent(program.programPrincipal.classification)}}</span>
								</div>
								
								<!-- Titulo del programa para largometrajes -->
								<div v-else>
									<p class="text-orange principalTitle work-break" :class="[durationProgramTitleLargometraje(program.programPrincipal)]">"{{ program.programPrincipal.programTitle }}"<p>
									<p class="principalTitle text-blue-color work-break style_text_film" :class="[durationProgram(program)]">{{ program.programPrincipal.materialTitle }}
										<!-- CLASIFICACION -->
										<span v-if="program.programPrincipal.isClasification && program.programPrincipal.classification !== ''" :style="{color: program.programPrincipal.clasificationColor}" :class="[isClassificationFilmsShow(program.programPrincipal)]" class="pl-2">{{ isHaveContent(program.programPrincipal.classification) }}</span>
									</p>
								</div>
								<!-- <div class="principalTitle"> -->
									<!-- _________  Temporada  __________ -->
									<!-- <p v-if="program.programPrincipal.isTemporada && program.programPrincipal.materialHasChapter == 'Si' && program.programPrincipal.season != '' && program.programPrincipal.season != null" :style="{color: program.programPrincipal.seasonColor}" :class="[sizeTextPrice(program.programPrincipal), 'text-center font_weight_500']"> {{ program.programPrincipal.season }}° TEMPORADA </p> -->
									<!-- <p v-if="program.programPrincipal.season != '' && program.programPrincipal.season != null" :class="[sizeTextPrice(program.programPrincipal), 'text-center font_weight_500 text-green']"> {{ program.programPrincipal.season }}° TEMPORADA </p> -->
									<div style="letter-spacing: -0.5px; font-weight: 100" :style="{color: program.programPrincipal.codProviderColor}" v-if="program.programPrincipal.IsCodProvider && program.programPrincipal.materialHasChapter == 'No' && isLargometraje(program.programPrincipal.typeOfContent)" :class="[isTempYcodeFeatureFilmSize(program.programPrincipal)]"> 
										{{ isHaveContent(program.programPrincipal.codeFeatureFilm) }}
									</div>
								<!-- </div> -->

                                <!-- NOTA GENERAL -->
									<div v-if="program.programPrincipal.generalNoteBoss && program.programPrincipal.generalNoteBoss !== '' && calculateTime(program.programPrincipal) > '00:45:00'" class="flex-content justify-content-center general-note-style work-break text-center line-height-11" :class="[sizeTextGeneralNote(program)]" v-html="program.programPrincipal.generalNoteBoss"></div>
							</div>
							<div class="boxAllDays box_content" :class="[durationProgramResize(program.programPrincipal)]">
								<!-- tengo mas de un dia -->
								<div class="boxByDay" v-for="(day, index) in program.programByDay" :key="index" :style="`grid-column: ${index+1} / span 1; backgroundColor: ${day.bgColorByProgram}`" >
									
									<div v-if="verificandoCantidadDeCapitulos(day.chapters, program.programByDay, program.programPrincipal.programTitle, program.programPrincipal)" class="contentBoxByChapter p-absolute">
										<div :class="[day.chapters.length == 1 ? 'contentBoxByChapter' : '', 'box_content_chap']">

											<div v-if="day.nota && day.nota !== ''" class="note note-style-middle line-height-9 text-color-note" v-html="day.nota"></div>
											<div v-if="day.noteDay && day.noteDay !== ''" class="note note-style-middle line-height-9 text-color-note" v-html="day.noteDay"></div>

											<div class="boxByChapterHead flex-content justify-content-center" v-for="(chapter, i) in day.chapters" :key="i" :class="[conditionalChap(program.programPrincipal, day)]">
												<!-- __________ Capitulos ___________ -->
												<div :class="[isLargometraje(program.programPrincipal.typeOfContent) && conditionalDurationProgram(program.programPrincipal) ? 'status_style': '', 'statusByChapterText', sizeStatus(program.programPrincipal)]" v-if="isHaveStatus(chapter)">
													<span  v-if="chapter.numChapter && chapter.numChapter !== ''" class="text-orange"> {{ chapter.numChapter }} </span> 
												</div>
												<div style="width: 100%; max-width: 100%;" class="boxDataByChapter">
													<!-- NÚMERO DE CAPITULO -->
													<p class="pr-2 d_inline_block" v-if="day.IsCap" :style="{color: day.chapterColor}">{{ chapter.numChapter }}</p>
													<p v-if="day.EstTemp && chapter.seasonInfo == 'Inicio de Temporada'" :style="{color: day.seasonStateColor}" class=" d_inline_block"> Inicio de Temp.</p>
													<p v-if="day.EstTemp && chapter.seasonInfo == 'Fin de Temporada'" :style="{color: day.seasonStateColor}" class="text-red-color  d_inline_block"> Fin de Temp.</p>
														<!--  PRECIO POR PASADA DE LARGOMETRAJES  -->		
													<p v-if="day.IsPricePass && chapter.priceByPass !== '' && isLargometraje(program.programPrincipal.typeOfContent)"  :style="{color: day.pricePassColor}">
														{{isPrice(chapter.priceByPass)}}
													</p>
													<!-- PRECIO POR PASADA DE LOS CAPITULOS -->
													<p :style="{color: day.pricePassChapterColor}" class="padding-right-5 d_inline_block" v-if="Boolean(day.pricePassChapter) && chapter.priceByPass !== '' && !isLargometraje(program.programPrincipal.typeOfContent)">
														<span v-if="chapter.priceByPass && chapter.priceByPass !== ''" >
															{{isPrice(chapter.priceByPass)}}
														</span>
													</p>

													<!-- PRECIO UNITARIO DE LOS CAPITULOS -->
													<p v-if="Boolean(day.priceChapter) && !isLargometraje(program.programPrincipal.typeOfContent)" class="padding-right-5 d_inline_block" :style="{color: day.priceChapterColor}">
														<span v-if="Boolean(day.priceChapter) == true">
															{{isPrice(chapter.priceByChap)}}
														</span>
													</p>

													
													<!-- ESTADO POR CAPITULO -->
													<p v-if="day.Estado && chapter.status !== ''" :class="[isLargometraje(program.programPrincipal.typeOfContent) && conditionalDurationProgram(program.programPrincipal) ? 'status_style': '','statusByChapterText', sizeStatus(program.programPrincipal), 'd_inline_block']">
														<span v-if="chapter.rerun" :style="{color: day.rerunChapterColor}">Rerun </span> <span v-if="chapter.rerun && chapter.estreno">-</span>
														<span v-if="chapter.estreno" :style="{color: day.stateChapterColor}"> Estreno </span> 
														<span v-if="chapter.ongoing" class="text-celeste"> {{ '(ONGOING)'}} </span> 
														<span v-if="day.chapters.length>1 && day.chapters.length-1 !== i">/</span>
													</p>
													<!-- __________Actors___________ -->
													<div v-if="isShowActors(program.programPrincipal)" :class="[sizeTextActors(program.programPrincipal)]">
														<p class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px"> {{ program.programPrincipal.firstActor }} </p>
														<p class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px"> {{ program.programPrincipal.secondActor }} </p>
													</div>
												</div>
											</div>
										</div>
									</div>
										
									<div v-else class="boxByChapterHead flex-content justify-content-center p-absolute bottom-0" :class="[conditionalChap(program.programPrincipal, day)]">
										<div style="width: 100%; max-width: 100%;" class="boxDataByChapter">
											<div v-if="day.noteDay && day.noteDay !== '' " class="note note-style-middle line-height-9" v-html="day.noteDay" ></div>
											<span class="text-blue ocupandoContenedor work-break" v-if="calculateTime(program.programPrincipal) > '00:30:00'" v-html="showChaptersInLine(day.chapters, day, program.programPrincipal.typeOfContent)"> </span> 
											<!-- __________Actors___________ -->
											<div v-if="isShowActors(program.programPrincipal)" :class="[sizeTextActors(program.programPrincipal)]">
												<p class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px"> {{ program.programPrincipal.firstActor }} </p>
												<p class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px"> {{ program.programPrincipal.secondActor }} </p>
											</div>
										</div>
									</div>

								</div>
							</div>
						</div>
					</div>
					<gridDays :days="generateDays()" :sizeLetters="'font-i-18 d-flex flex-content justify-content-center'" :space="'pl-5'"/>
				</div>

				<!--Schedule-->
				<div>
					<div>
						<div class="grid-schedule-title box_style_border_rigth width-50" ref="scrollSchedule">
							<div style="height: 31px"></div>
						</div>

						<div class="box_style box_style_border_rigth">
							<div class="grid-schedule resize o-hidden" style="grid-row:1/4"> 
								<p class="font-i-16"> 05:16 </p>
							</div>
							<div class="grid-schedule resize flex-content justify-content-center font-i-12" 
							v-for="(time, index) in timeForDay" :key="index" 
							:style="`grid-area: ${(6*  index) +4} / 1/ span 6 / 2`">
								<p class="font-i-16">{{ time }}</p>
							</div>
							<div class="grid-schedule resize o-hidden border-none" style="grid-row:286/289">
								<p class="font-i-16"> 05:00 </p>
							</div>
						</div>

						<div class="grid-schedule-title box_style_border_rigth">
							<div style="height: 31px"></div>
						</div>
					</div>
				</div>
			</div>
		</el-main>

	</div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import ModalContentComponent from './components/ModalContent'
import Title from '@/components/Title.vue'
import { getFirstDay, convertNumberFormatUsd } from '@/utils/calculateTime.js'
import { sizeLetttersAboutProgram, calculateSchedule, sizeLetttersAboutProgramCompare } from '@/utils/calculateSizeLetters.js'
import gridDays from '@/components/grid/gridDays'
import { addingZerosToTheDay, convertFormatDayForCrusses, convertHourDate} from '@/utils/calculateTimePrograms.js'
import { modelProgramByDay } from '@/utils/util.js'

export default {
	components: {
		'app-title': Title,
		ReturnButton,
		ModalContentComponent,
		gridDays
	},
	data () {
		return {
			dataTable: '',
			dateSearch: '',
			firstDayOfWeek: '',
			firstDay: JSON.parse(sessionStorage.getItem('firstDay')) ,
			secondDay: JSON.parse(sessionStorage.getItem('secondDay')) ,
			thirdDay: JSON.parse(sessionStorage.getItem('thirdDay')) ,
			fourthDay: JSON.parse(sessionStorage.getItem('fourthDay')) ,
			fifthDay: JSON.parse(sessionStorage.getItem('fifthDay')) ,
			sixthDay: JSON.parse(sessionStorage.getItem('sixthDay')) ,
			lastDay: JSON.parse(sessionStorage.getItem('lastDay')) ,
			month: '',
			month2: '',
			year: '',
			year2: '',
			startDate: '',
      endDate: '',
      orderByProgram: [],
			// orderByProgram: JSON.parse(sessionStorage.getItem('orderByProgram')) ,
			idOfPrograms: [],
			hour: 5,
			minute: 0,
			contentHtml: '',
			dateString: JSON.parse(sessionStorage.getItem('dateString')),
			modalInfo: false,
			programSelected: {},
			transmission: [],
			allDiasByProgram: [],
			timeForDay: [],
			isSelectColor: false,
			checkAllDays: [],
			changeStatus: '',
			clasificationColor: '',
      notShowSchedule: false,
      dataAllWeek: [],
			allProgramsWithGrid: JSON.parse(sessionStorage.getItem('allProgramsWithGrid')),
			chanelTransmission: this.$localStorage.get('channelTransmition'),
			printView: this.$route.params.grid
		}
	},
	mounted(){
		let alturas = []
		for(let i=1; i<=288; i++){alturas.push['6px']};
		let templateRows = alturas.join(' ');
		const items = document.querySelectorAll('.grid-schedule');
		const boxes = document.querySelectorAll('.box_style');
		const grids = document.querySelectorAll('.grid-programs')
		boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
		grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)		

		window.addEventListener('mouseup',()=>{
			items.forEach(item=>{
				let style = item.getAttribute('style').split(';');
				item.setAttribute('style',style[0])
			})
		})

		var ro = new ResizeObserver( entries => {
			for (let entry of entries) {
				const cr = entry.contentRect;
				const hg = parseInt(cr.height);
				let maxIndex = 6;
				let gridLine = parseInt(entry.target.style.gridRow);
				let divBorder = gridLine==286? 0:3;				
				maxIndex = gridLine==1 || gridLine==286 ? 3:6
				let calculateHeigth = Math.floor((Math.floor(hg)+divBorder)/maxIndex)
				for(let j=gridLine -1; j<= gridLine+maxIndex-2; j++){
					alturas[j]= calculateHeigth+'px';
				}
				templateRows = alturas.join(' ');
				boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
				grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
			}
		});

		items.forEach(item=>ro.observe(item))
	},
	methods: {
		isHaveStatus(data) {
			const {estreno, ongoing, rerun} = data
			if(!estreno && !ongoing && !rerun) {
				return false
			} else {
				return true
			}
		},
		verificandoCantidadDeCapitulos (arrayDeCap, arrayByDay,  titleProgram, infoProgramPrincipal) {
			const durationProgram = this.calculateTime(infoProgramPrincipal)
			const diasAtransmitir = arrayByDay.length
			const numeroDePalabrasTitulo = titleProgram.length
			const cantCap = arrayDeCap.length
			if (diasAtransmitir > 1 && durationProgram >=  '01:00:00' && cantCap > 3 ) {
				return false
			}
			else if (durationProgram <  '01:00:00' && cantCap > 1 ) {
				return false
			}
			else if (diasAtransmitir == 1 && cantCap >= 3 ) {
				return false
			}
			else {
				return true
			}
		},
		showChaptersInLine (arrayChapters, day, typeOfContent) {
			let chapters = ''
			const {rerunChapterColor, chapterColor, stateChapterColor, pricePassChapterColor, priceChapterColor, EstTemp, seasonStateColor, IsCap, Estado, priceChapter, pricePassChapter} = day
			arrayChapters.map((chap, i, arr) => {
				const {numChapter, rerun, estreno, ongoing, priceByPass, priceByChap, seasonInfo, status} = chap
				let statusRerun = Estado && status !== '' && rerun ? `<span :style="color: ${rerunChapterColor}"> RERUN </span>` : false
				let statusEstreno = Estado && status !== '' && estreno ? `<span style="color: ${stateChapterColor}"> ESTRENO </span> ` : false
				let statusOngoing = Estado && status !== '' && ongoing ? ` <span class="text-celeste"> (ONGOING) </span>` : false
				let chapter = IsCap && numChapter && numChapter !== '' ? ` <span style="color: ${chapterColor}"> ${numChapter} </span>` : false
				let priceByPassText = Boolean(pricePassChapter) && priceByPass !== '' && !this.isLargometraje(typeOfContent) ? `<span style="color: ${pricePassChapterColor}"> ${this.isPrice(priceByPass)} </span>` : false
				let priceByChapText = Boolean(priceChapter) && !this.isLargometraje(typeOfContent) ? `<span style="color: ${priceChapterColor}"> ${this.isPrice(priceByChap)} </span>` : false
				let conditionalName = seasonInfo && seasonInfo == 'Fin de Temporada' ? 'Fin de Temp.' : 'Inicio de Temp.'
				let statusOfTemp = EstTemp && seasonInfo && seasonInfo !== '' ? `<span style="color: ${seasonStateColor}"> ${conditionalName} </span>` : false
				if (i == (arr.length - 1 )) {
					if (statusRerun ||  statusEstreno || statusOngoing || priceByPassText || priceByChapText || statusOfTemp) {
						chapters += `${this.contentForChapter(chapter, statusOfTemp, priceByPassText, priceByChapText, statusRerun, statusEstreno, statusOngoing)}`
					}
					else if(chapter) {
						chapters += `${chapter}` 
					}
				} else {
					if (statusRerun ||  statusEstreno || statusOngoing || priceByPassText || priceByChapText || statusOfTemp) {
						chapters += `${this.contentForChapter(chapter, statusOfTemp, priceByPassText, priceByChapText, statusRerun, statusEstreno, statusOngoing)};`
					}
					else if(chapter){
						chapters += `${chapter};`

					}
				}
				let onlyText = chapters.replace(/<[^>]*>?/g, '')

			})
			// console.log(chapters, 'chapters')
			return chapters
		},
		contentForChapter(chapter, statusOfTemp, priceByPassText, priceByChapText, statusRerun, statusEstreno, statusOngoing) {
			let arr = []
			if (chapter) {
				arr.push(chapter)
			}
			if (statusOfTemp) {
				arr.push(statusOfTemp)
			}
			if (priceByPassText) {
				arr.push(priceByPassText)
			}
			if (priceByChapText) {
				arr.push(priceByChapText)
			}
			if (statusRerun) {
				arr.push(statusRerun)
			}
			if (statusEstreno) {
				arr.push(statusEstreno)
			}
			if (statusOngoing) {
				arr.push(statusOngoing)
			}
			return arr.join('')
		},
		conditionalChap(program, day) {
			const {typeOfContent} = program
			const {IsCap, Estado,chapters} = day
			let counterChap = day.chapters.length
			if(this.isLargometraje(typeOfContent)) {
				return 'width_100'
			} else {
				// return IsCap && !Estado && chapters.length === 1 === 1 ?  'width_100' : 'width_auto'
				return 'width_100'
			}
		},
		isTempYcodeFeatureFilmSize(timeData) {
			let time = this.calculateTime(timeData)
			let style
			if(time <= '00:45:00') {
				style = 'font-i-12'
			} else if (time > '00:45:00' && time <= '01:30:00') {
				style = 'font-i-13'
			} else if (time > '01:30:00' && time <= '02:30:00') {
				style = 'font-i-14'
			} else {
				style = 'font-i-15'
			}
			return style
		},
		sizeTextPrice(timeData, day) {
			let time = this.calculateTime(timeData)
			let style
			if(time <= '00:10:00') {
				style = 'font-i-10'
			} else if (time > '00:30:00' && time <= '00:45:00') {
				style = 'font-i-11'
			} else if (time > '01:15:00' && time <= '02:00:00') {
				style = 'font-i-12'
			} else {
				style = 'font-i-13'
			}
			return style
		},
		sizeStatus(data) {
			const {programTitle} = data 
			const time = this.calculateTime(data)
			if(time <= '00:10:00') {
				return 'font-i-10'
			} else if (time > '00:30:00' && time <= '00:45:00') {
				return 'font-i-11 pb-1'
			} else if (time > '01:15:00' && time <= '02:00:00') {
				return 'font-i-12 pb-1'
			} else {
				return 'font-i-13 pb-1'
			}
		},
		sizeTextGeneralNote(program) {
			const {generalNote} = program.programPrincipal
			let time = this.calculateTime(program.programPrincipal)
			let counterDays = program.programByDay
			let generalNoteTransform = (generalNote.split('>')[2]).split('<')[0]
			let response
			if(time <= 10) {
				response = 'font-i-10'
			} else {
				response = 'font-i-13'
			}

			if(counterDays.length <= 3) {
				response = generalNoteTransform.length >= 15 ? 'font-i-10' : 'font-i-12'
			}
			return `${response} pl-5 pr-5`
		},
		sizeTextActors(data) {
			const {firstActor, secondActor} = data
			let time = this.calculateTime(data)
			let style
			if(time <= '01:00:00') {
				style = 'font-i-9 pb-1'
			} else if(time > '01:00:00' && time <= '02:00:00') {
				style = 'font-i-10 pb-1'
			} else {
				style = 'font-i-12 pb-1'
			}
			let firstActorLength = firstActor ? firstActor.length : 0
			let secondActorLength = secondActor ? secondActor.length : 0
			return (firstActorLength + secondActorLength) < 28 ? `${style} style_actors` : style
		},
		isLargometraje(value) {
			if(value == 'Largometrajes' || value == 'LARGOMETRAJES') {
				return true
			} else {
				return false
			}
		},
		calculateTime(val) {
			const {scheduleStartHour, scheduleStartMin, scheduleEndHour, scheduleEndMin, programTitle} = val
			
			let timeStartProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleStartHour, scheduleStartMin), val.programDate, 'start' )
			let timeEndProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleEndHour, scheduleEndMin), val.programDate, 'end' )

			let timeStart = new Date(String(timeStartProgramCardsData)).getTime()
			let timeEnd = new Date(String(timeEndProgramCardsData)).getTime()
			let hourDiff = timeEnd - timeStart
			let secDiff = hourDiff / 1000
			let minDiff = hourDiff / 60 / 1000
			let hDiff = hourDiff / 3600 / 1000
			let result = {}
			result.hours = Math.floor(hDiff)
			result.minutes = minDiff - 60 * result.hours
			
			let response =  `${this.calculateHour(String(result.hours))}:${this.calculateHour(String(result.minutes))}:00`
			return response
		},
		generateDays() {
			const days = [
				{
					name: 'Lunes',
					number: addingZerosToTheDay(this.firstDay),
				},
				{
					name: 'Martes',
					number: addingZerosToTheDay(this.secondDay),
				},
				{
					name: 'Miercoles',
					number: addingZerosToTheDay(this.thirdDay),
				},
				{
					name: 'Jueves',
					number: addingZerosToTheDay(this.fourthDay),
				},
				{
					name: 'Viernes',
					number: addingZerosToTheDay(this.fifthDay),
				},
				{
					name: 'Sábado',
					number: addingZerosToTheDay(this.sixthDay),
				},
				{
					name: 'Domingo',
					number: addingZerosToTheDay(this.lastDay),
				}
			]
			return days
		},
		isPrice(val) {
			if(val && val !== '') {
				return `USD ${this.getFormat(val)}`
			} else {
				return 'USD 0.00'
			}
		},
		conditionalDurationProgram(value) {
			let conditional = this.styleByDurationProgram(value)
			// console.log(conditional, 'c')
			if(conditional == 'program_normal') {
				return true
			} else {
				return false
			}
		},
		isHaveContent(val) {
			console.log(val, 'isHaveContent')
			let value
			if(val && val !== '') {
				value = `(${val})`
			} else {
				value = ''
			}
			return value
		},
		isClassificationFilmsShow(val) {
			const data = this.calculateTime(val)
			const {typeOfContent} = val
			let esLargometraje = this.isLargometraje(typeOfContent)
			if(esLargometraje) {
				return 'd-inline-block'
			} else {
				return data >= '01:00:00' ? 'textCollapse' : 'd-inline-block'
			}
			
		},
		openModal(program) {   
			this.programSelected = program.programPrincipal
			this.allDiasByProgram = program.programByDay
			this.modalInfo = true
		},
		closeModal() {
			this.modalInfo = false
		},
		addClassToProgramTitle (program) {
			let hasChapters = false
			if(!(program.programByDay.length > 1)){
				if(!(program.programByDay[0].material.numChapters.length > 0)){
					hasChapters = true
				}
			}
			return hasChapters
		},
		handleScroll (event) {
		  let sticky = this.$refs.scroll
			if (window.pageYOffset >= 300) {
				sticky.classList.add("sticky")
			} else {
				sticky.classList.remove("sticky");
			}

			let stickySchedule = this.$refs.scrollSchedule
			if (window.pageYOffset >= 300) {
				stickySchedule.classList.add("sticky")
			} else {
				stickySchedule.classList.remove("sticky");
			}

			let stickyScheduleRight = this.$refs.scrollScheduleRight
			if (window.pageYOffset >= 300) {
				stickyScheduleRight.classList.add("sticky")
			} else {
				stickyScheduleRight.classList.remove("sticky");
			}
    	},
		returnPage () {
      		this.$router.push({ name: 'views'})
		},
		getWeek (week) {
			let res = this.allProgramsWithGrid
			console.log(res, 'res')
			this.orderByProgram = []
			this.idOfPrograms = []
			// const responseText = 'Week not found'
			const responseText = "Week not found weekDate"
			// const {weekDate} = this.allProgramsWithGrid
			if(res !== responseText) {
				console.log( 'holaaa')
				// this.dataAllWeek = weekDate
				const {programs} = res.length > 0 ? res[0] : res
				// FILTRO POR CANAL DE TRANSMISION
				let isTrue = false
				let programsByChannel = []
				programs.map((program)=>{
					if(program.refProgram.checkedChanels.length > 0){
						program.refProgram.checkedChanels.map((channel)=> {
							if(channel.toLowerCase() == this.chanelTransmission.toLowerCase()){
								programsByChannel.push(program)
							}
						})
					} else {
						programsByChannel.push(program)
					}
				})

				// RECORRE LA DATA QUE TRAE LA RESPUESTA
				programsByChannel.map((program)=>{
					const {refProgram: {_id}} = program

					const object = {
						programPrincipal: this.modelPrincipalProgram(program),
						programByDay: [modelProgramByDay(program)]
					}

					if(this.idOfPrograms.includes(_id) == false){
						// INSERTA LOS PROGRAMAS SI SUS ID'S NO HAN SIDO INSERTADOS ANTERIORMENTE
						this.idOfPrograms.push(_id)
						this.orderByProgram.push(object)
					} else {
						const {refProgram: {codeDays}} = program

						let arrSamePrograms = []
						this.orderByProgram.map((program, index)=>{
							if(program.programPrincipal._id == _id){
								arrSamePrograms.push(index)
							}
						})
						
						let daySelected = this.getDayCode(program.completeDate)
						
						let addToProgram = false
						//RECORRE EL ARRAY DE PROGRAMAS QUE SE HAN CREADO PERO QUE PERTENECEN AL MISMO PROGRAMA
						for(let i=0; i<arrSamePrograms.length; i++){
							let programSelected = this.orderByProgram[arrSamePrograms[i]]
							let daysSaved = []
							//GUARDA EN UN ARRAY LOS DIAS QUE SE HAN GUARDADO EN EL PROGRAMA
							programSelected.programByDay.map((programDay)=>{
								const day = programDay.completeDate
								const daySaved = this.getDayCode(day)
								daysSaved.push(daySaved)
							})
							
							//RECORRE LOS DIAS DEL PROGRAMA 
							codeDays.map((day, index)=>{
								//VERIFICA EL DIA SELECCIONADO
								if(day == daySelected){
									//SI ES DOMINGO SE CAMBIA A 8 PORQUE CON EL 1 NO VALIDA CORRECTAMENTE
									daySelected = (daySelected == 1)? 8: daySelected
									//VALIDA SI EL DIA SELECCIONADO ES CORRELATIVO EN EL ARRAY DE DIAS DEL PROGRAMA
									if(codeDays.includes(daySelected-1) || codeDays.includes(daySelected+1)){
										//RECORRE LOS DIAS DEL PROGRAMA YA INGRESADOS
										daysSaved.map((savedDay)=>{
											//VERIFICA QUE EL DIA SELECCIONADO SEA CORRELATIVO A LOS DIAS QUE YA ESTAN INGRESADOS
											if(savedDay == (daySelected-1) || savedDay ==  (daySelected+1)){
												// VERIFICA QUE LOS DIAS CONTENGAN EL MISMO HORARIO
												const indexArrProgram = programSelected.programByDay.length -1
												const lastProgram = programSelected.programByDay[indexArrProgram]
												const programByDay = modelProgramByDay(program)
												
												let lastProgramTimeStart = this.convertToMinutes(lastProgram.scheduleStartHour, lastProgram.scheduleStartMin)
												let lastProgramTimeEnd = this.convertToMinutes(lastProgram.scheduleEndHour, lastProgram.scheduleEndMin)

												let programSelectedTimeStart = this.convertToMinutes(programByDay.scheduleStartHour, programByDay.scheduleStartMin)
												let programSelectedTimeEnd = this.convertToMinutes(programByDay.scheduleEndHour, programByDay.scheduleEndMin)

												if((lastProgramTimeStart == programSelectedTimeStart) && (lastProgramTimeEnd == programSelectedTimeEnd)){
													addToProgram = true
													programSelected.programByDay.push(modelProgramByDay(program))
												} else {
													addToProgram = false
												}
												
											}
										})
									}
								}
							})
						}

						//AGREGA COMO NUEVO PROGRAMA SI NO ES UN DIA CORRELATIVO
						if(addToProgram == false){
							this.orderByProgram.push(object)
						}

					}
				})
			}
				
			this.orderByProgram = this.sortByHour(this.orderByProgram)
			this.fillingGrid(this.orderByProgram)
		},
		modelPrincipalProgram(program){
			let exitMaterialReferencia = program.materialReferencia ? program.materialReferencia.typeOfContent : ''
			let conditionalTypeOfContent = program.typeOfContent ? program.typeOfContent : exitMaterialReferencia
			const programPrincipal = {
				_id: program.refProgram._id,
				arrCheckCrosses: program.refProgram.arrCheckCrosses,
				checkedChanels: program.refProgram.checkedChanels,
				checkedSignals:program.refProgram.checkedSignals ,
				codProgram: program.refProgram.codProgram,
				codeDays: program.refProgram.codeDays,
				geminisCode: program.refProgram.geminisCode,
				programTitle: program.refProgram.programTitle,
				scheduleEndHour: program.scheduleEndHour,
				scheduleEndMin: program.scheduleEndMin,
				scheduleStartHour: program.scheduleStartHour,
				scheduleStartMin: program.scheduleStartMin,
				transmissionDays: program.refProgram.transmissionDays,
				classification: program.classification,
				isTemporada: program.isTemporada  || false,
				isClasification: program.isClasification || false,
				clasificationColor: program.clasificationColor,
				seasonColor: program.seasonColor,
				isUnitPrice: program.isUnitPrice  || false,
				unitPriceColor: program.unitPriceColor,
				generalNote: program.generalNote,
				IsCodProvider: program.IsCodProvider  || false,
				providerCode: program.providerCode,
				transmissionDaysDescription: this.dayStartAndDayEnd(program.refProgram.transmissionDays),
				typeOfContent: conditionalTypeOfContent,
				materialTitle: program.materialTitle,
				materialHasChapter: program.materialHasChapter,
				materialType: program.materialType,
				firstActor: program.firstActor,
				secondActor: program.secondActor,
				unitPrice: program.unitPrice,
				season: program.season,
				stringMaterialType: program.stringMaterialType,
				codeFeatureFilm: program.codeFeatureFilm,
				materialExisting: program.materialExisting,
				material: program.material,
				generalNoteBoss: program.generalNoteBoss,
				materialReferencia: program.materialReferencia,
				material: program.material,
				programDate: program.programDate,
				Estado: program.Estado,
				priceChapter: program.priceChapter,
				pricePassChapter: program.pricePassChapter,
				codProviderColor: program.codProviderColor
			}
			return programPrincipal
		},
		convertToMinutes(hours, minutes){
			const result = (hours * 60) + minutes
			return result
		},
		sortByHour(programs) {
			return programs.slice().sort(function(a, b) {
				//SE ORDENA POR TOTAL DE MINUTOS
				const firstProgramMinutesTotal = (a.programPrincipal.scheduleStartHour * 60) + a.programPrincipal.scheduleStartMin
				const secondProgramMinutesTotal = (b.programPrincipal.scheduleStartHour * 60) + b.programPrincipal.scheduleStartMin
				
				return firstProgramMinutesTotal - secondProgramMinutesTotal;
			});
		},
		getDayCode (day){
			let daySelected = day.split(' ')[0]
			let dayCode = ''
			switch(daySelected){
				case 'Lunes':
					dayCode = 2
				break;
				case 'Martes':
					dayCode = 3
				break;
				case 'Miércoles':
					dayCode = 4
				break;
				case 'Jueves':
					dayCode = 5
				break;
				case 'Viernes':
					dayCode = 6
				break;
				case 'Sábado':
					dayCode = 7
				break;
				case 'Domingo':
					dayCode = 1
				break;
			}

			return dayCode
		},
		addingZerosToTheDay (day) {
			if(String(day).length < 2){
				day = '0'+ day
			}
			return day
		},
	  fillingGrid (data) {
			let programs = data
			this.contentHtml = ''
			programs.map((program, index) => {
				let template = ''
				const nameProgram = program.programPrincipal.programTitle	
				const arrDays = program.programByDay.map((e)=> (this.getDayCode(e.completeDate) == 1)?8:this.getDayCode(e.completeDate))

				const daysInOrder = arrDays.sort()

				let hourStart = program.programPrincipal.scheduleStartHour
				let hourEnd = program.programPrincipal.scheduleEndHour
				let minEnd = program.programPrincipal.scheduleEndMin
        let minStart = program.programPrincipal.scheduleStartMin

        if (hourStart <5 ) {
          hourStart = Number(hourStart) + 24
        }
        else if (hourStart == 5 && hourEnd !== 5 && minStart != 16 && minEnd == 16 ) {
          hourStart = Number(hourEnd) + 24
        }
        
        if (hourEnd <5) {
          hourEnd = Number(hourEnd) + 24
        } 
        else if (hourEnd == 5 && minEnd<=16) {
          hourEnd = Number(hourEnd) + 24
        }

      	const totalMinutesStart = (Number(hourStart)*60) + Number(program.programPrincipal.scheduleStartMin)
				const totalMinutesEnd = (Number(hourEnd)*60) + Number(minEnd)
        
				let initGrid = Math.round(totalMinutesStart/5 - 63.2 )
				let finalGrid = Math.round(totalMinutesEnd/5 - 63.2 )
				const concatGrid = (initGrid+1) +' / '+ (daysInOrder[0]-1) + ' / span '+ (finalGrid - initGrid) + ' / ' + (daysInOrder[(daysInOrder.length)-1])

				template = `<div class="grid-programsByDay" style="grid-area: ${concatGrid};">
								${nameProgram}
							</div>`
				this.contentHtml += template

				let divObj = 'cell-'+index
				this.$refs[divObj] && this.$refs[divObj][0] ? this.$refs[divObj][0].style.gridArea = concatGrid : ''
			})
		},
		dayStartAndDayEnd(val) {
			if(val && val.length > 1) {
				const counter = val.length
				const connect = val[0] == 'Lunes' ? 'a' : 'y'
				const counterCondicional = connect == 'a' ? 5 : 2
				const text = `${val[0]} ${connect} ${val[counter-1]}`
				return {
					text,
					value: counterCondicional
				}
			} else if(val && val.length == 1) {
				return {
					text: val[0],
					value: 1
				}
			}
		},
		/*___________________Métodos para crear el array de las horas ____________________*/
		getTime(firstTime, secondTime, operator) {
			const secs1 = this.stringToSeconds(firstTime)
			const secs2 = this.stringToSeconds(secondTime)
			let secsDif
			if(operator == 'sum') {
				secsDif = secs1 + secs2
			} else {
				if(secs1 > secs2) {
					secsDif = secs1 - secs2
				} else {
					secsDif = secs2 - secs1
				}
			}
			return this.secondsToTime(secsDif)
    	},
		stringToSeconds(tiempo) {
			let sep1 = tiempo.indexOf(":")
			let sep2 = tiempo.lastIndexOf(":")
			let hor = tiempo.substr(0, sep1)
			let min = tiempo.substr(sep1 + 1, sep2 - sep1 - 1)
			return Number(min) * 60 + Number(hor) * 3600
		},
		secondsToTime(secs) {
			let hor = Math.floor(secs / 3600)
			let min = Math.floor((secs - hor * 3600) / 60)
			let sec = secs - hor * 3600 - min * 60
			// return this.padNmb(hor, 2) + ":" + this.padNmb(min, 2)
			return (
				this.padNmb(hor, 2) +
				":" +
				this.padNmb(min, 2) +
				":" +
				this.padNmb(sec, 2)
			)
		},
		padNmb(nStr, nLen) {
			const sRes = String(nStr)
			const sCeros = "0000000000"
			return sCeros.substr(0, nLen - sRes.length) + sRes
		},
		recordArray(firstTime, secondTime, operator, record) {
			const arr = [firstTime]
			for (let i = 0; i < record; i++) {
				arr.push(this.getTime(arr[i], secondTime, operator));
			}
			return arr
		},
		formatedArray() {
			const b = this.recordArray("05:30:00", "00:30:00", 'sum', 36).concat(this.recordArray("00:00:00", "00:30:00", 'sum', 9 ))
			const d = b.map((e) => e.slice(0, 5))
			return d
		},
		isHaveContent(val) {
			let value
			if(val) {
				value = `(${val})`
			} else {
				value = ''
			}
			return value
		},
		noteDiv(classAsigned, nota) {
			const reviewClass = classAsigned.replace('el-textarea__inner', '') 
			const classSelect = reviewClass.replace('textarea-style', '')
			const template = nota && nota !== ''? `<div><p class="${classSelect}">${nota}</p></div>` : ''
			return template
		},
		isHaveActors(val) {
			let value, arr
			if(val && val.artisticInfo) {
				let exitsActors = val.artisticInfo.length > 0 ? val.artisticInfo[0].mainActors : []
				let counterActors = exitsActors.length
				if(counterActors > 2) {
					arr = [exitsActors[0], exitsActors[1]]
				} else {
					arr = exitsActors
				}
				value = arr
			}
			return value
		},
		calculateScheduleHours(scheduleStartHour, scheduleStartMin) {
			return calculateSchedule(scheduleStartHour, scheduleStartMin)
		},
		calculateTime(val) {
			const {scheduleStartHour, scheduleStartMin, scheduleEndHour, scheduleEndMin, programTitle} = val
			
			let timeStartProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleStartHour, scheduleStartMin), val.programDate, 'start' )
			let timeEndProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleEndHour, scheduleEndMin), val.programDate, 'end' )
			
			let timeStart = new Date(String(timeStartProgramCardsData)).getTime()
			let timeEnd = new Date(String(timeEndProgramCardsData)).getTime()
			let hourDiff = timeEnd - timeStart
			let secDiff = hourDiff / 1000
			let minDiff = hourDiff / 60 / 1000
			let hDiff = hourDiff / 3600 / 1000
			let result = {}
			result.hours = Math.floor(hDiff)
			result.minutes = minDiff - 60 * result.hours
			
			let response =  `${this.calculateHour(String(result.hours))}:${this.calculateHour(String(result.minutes))}:00`
			return response
		},
		conditionalDate(val) {
			let getTime = val.split(":")
			let getHour = String(getTime[0])
			let hour = this.calculateHour(getHour)
			let getMin = String(getTime[1])
			let min = this.calculateHour(getMin)
			let conditionalHour = hour === '00' ? '24' : hour
			// let time = val == '00:00' ? '24:00:00' : `${hour}:${min}:00`
			let time = `${conditionalHour}:${min}:00`
			return time
		},
		calculateHour(hour) {
			return hour.length >= 2 ? hour : `0${hour}`
		},
		styleClasification(val) {
			let classToAdd = (val.material.canned == false)?'text-marron':'text-red'
			const data = this.calculateTime(val)
			if(data <= '00:30:00') {
				classToAdd = 'hidden'
			} else if(data > '00:30:00' && data <= '01:00:00') {
				classToAdd = classToAdd + ' font-i-9 d-inline-block m-top-15'
			} else {
				classToAdd = classToAdd + ' font-i-14'
			}
			return classToAdd
		},
		styleTitlePrincipal(program){
			const {programTitle} = program[0]
			const data = this.calculateTime(program[0])
			let conditional = program.length == 1 ? true : false
			let time
			if(conditional) {
				if(data <= '00:10:00') {
					return sizeLetttersAboutProgramCompare(programTitle,'letters-small font-i-8 font-weight-0 m-0 p-i-0 width_auto', 'letters-small font-i-12 font-weight-0 m-i-0 p-i-0 width_auto', 14)
				} else {
					return this.sizeTitleOneDay(programTitle, data, 'p-i-0 width_auto m-i-0')
				}
			} else {
				return this.sizeTitle(programTitle, data)
			}
		},
		sizeTitle(programTitle, data, style_extra) {
			let time
			if(data <= '00:05:00') {
				time = sizeLetttersAboutProgramCompare(programTitle,'letters-small font-i-10 font-weight-0 m-i-0 p-i-0 width_auto', 'letters-small font-i-12 font-weight-0 m-i-0 p-i-0 width_auto', 14)
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-i-10 font-weight-0 p-i-0 width_auto  m-i-2', 'font-i-14 font-weight-0 m-i-2 p-i-0', 14)
			} else if(data > '00:15:00' && data <= '00:30:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-i-12 font-weight-0 ', 'font-i-16 font-weight-0  m-0', 14)
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-i-14 font-weight-0', 'font-i-16 m-0', 14)
			} else if (data > '01:00:00' && data <= '01:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-i-16 m-0 w-100 p-0', 'font-i-20 m-0')
			} else {
				time = sizeLetttersAboutProgram(programTitle, 'font-i-18 m-0 w-100 p-0', 'font-i-24 m-0')
			}
			return style_extra ? `${time} ${style_extra}` : time
		},
		sizeTitleOneDay(programTitle, data, style_extra) {
			let time
			if(data <= '00:05:00') {
				time = sizeLetttersAboutProgramCompare(programTitle,'letters-small font-i-10 font-weight-0 m-0 p-0 width_auto', 'letters-small font-i-12 font-weight-0 m-0 p-0 width_auto', 14)
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-i-10 font-weight-0 p-i-0 width_auto', 'font-i-12 font-weight-0 m-0', 14)
			} else if(data > '00:15:00' && data <= '00:30:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-i-12 font-weight-0 ', 'font-i-14 font-weight-0  m-0', 14)
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-i-13 font-weight-0', 'font-i-15 m-0', 14)
			} else if (data > '01:00:00' && data <= '01:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-i-15 m-0 w-100 p-0', 'font-i-17 m-0')
			} else {
				time = sizeLetttersAboutProgram(programTitle, 'font-i-17 m-0 w-100 p-0', 'font-i-19 m-0')
			}
			return `${time} ${style_extra}`
		},
		durationProgram(program) {
			const {programTitle, typeOfContent, codeFeatureFilm, materialTitle} = program.programPrincipal
			let counterDays =  program.programByDay.length
			let isHaveNote = [].concat.apply([], program.programByDay.map((e) => {
				let counter = []
					let {nota, generalNote} = e
					if(nota && nota !== '' && generalNote && generalNote !== '') {
						let notaText = (nota.split('>')[2]).split('<')[0]
						let generalNoteText = (generalNote.split('>')[2]).split('<')[0]
						counter.push({nota: notaText, generalNote: generalNoteText})
					} else {
						let obj = {}
						if(nota && nota !== '') {
							obj.nota = (nota.split('>')[2]).split('<')[0]
						}
						if(generalNote && generalNote !== '') {
							obj.generalNote = (generalNote.split('>')[2]).split('<')[0]
						}
						let haveContent = Object.keys(obj)

						haveContent.length >= 1 ? counter.push(obj) : null
					}
				return counter[counter.length -1] && counter.length >= 1? counter[counter.length -1] : []
			}))

			
			const data = this.calculateTime(program.programPrincipal)
			let conditional = this.isLargometraje(typeOfContent)
			codeFeatureFilm
			let time
			if(data <= '00:05:00') {
				time = 'letters-small font-i-8 font-weight-0 m-0'
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = sizeLetttersAboutProgram(materialTitle, 'font-i-8 font-weight-0', 'font-i-11 font-weight-0 m-0')
			} else if(data > '00:15:00' && data <= '00:30:00') {
				time = sizeLetttersAboutProgram(materialTitle, 'font-i-9 font-weight-0', 'font-i-12 font-weight-0 m-0')
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgram(materialTitle, 'font-i-12 font-weight-0', 'font-i-14 m-0')
			} else if(data > '01:00:00' && data <= '01:30:00') {
				time = sizeLetttersAboutProgram(materialTitle, 'font-i-14 font-weight-0', 'font-i-16 m-0')
			} else if(data > '01:30:00' && data <= '02:00:00') {
				// time = sizeLetttersAboutProgramCompare(materialTitle, 'font-i-16 font-weight-0', 'font-i-18 m-0', 35)
				time = 'font-i-16 m-0'
			} else {
				time = 'font-i-20 m-0'
			}
			let restructureSize
			if(isHaveNote.length > 0) {
				if(counterDays == 1) {
					restructureSize = this.risizeAboutLength(isHaveNote[0].nota, time, materialTitle)
				} else {
					restructureSize = time
				}
				
			} else {
				restructureSize = time
			}
			
			return `${restructureSize} p-i-0 width_auto`
		},
		risizeAboutLength(val, style, title) {
			let counter = val.length
			let styleText = style.split(' ')
			if(counter <= 40) {
				return style
			} else {
				styleText[0] = title.length >= 35 ? 'font-i-12' :'font-i-14' 
				return `${styleText.join(' ')} line-height-16`
			}
		},
		durationProgramResize(val) {
			const {programTitle} = val
			const data = this.calculateTime(val)
			let time
			if(data <= '00:05:00') {
				time = `programSmall`
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = `programMiddle`
			} else if(data > '00:15:00' && data <= '00:30:00') {
				time = `programRegular`
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = `programBig`
			} else {
				time = `programLarge`
			}
			return time
		},
		durationProgramTitleLargometraje(val) {
			const {programTitle} = val
			const data = this.calculateTime(val)
			let time
			if(data <= '00:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-i-8 ', 'font-i-9')
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-i-9', 'font-i-10')
			} else if(data > '01:00:00' && data <= '02:00:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-i-10', 'font-i-11')
			} else {
				time = 'font-i-12'
			}
			return `${time} line-height-11`
		},
		styleByDurationProgram(val) {
			const {programTitle} = val 
			const time = this.calculateTime(val)
			let style
			if (time <= '00:30:00') {
				style = 'program_small'
			} else if (time > '00:30:00' && time <= '00:45:00') {
				style = 'program_medium'
			} else if (time > '00:45:00' && time <= '01:15:00') {
				style = 'program_normal'
			} else if (time > '01:15:00' && time <= '01:55:00') {
				style = 'program_large'
			} else {
				style = 'program_xLarge'
			}
			if(this.printView == 'jefatura' && style == 'program_large') {
				style = `program_large_${this.printView}`
			}
			return style
		},
		isShowActors(data) {
			let response
			const {materialHasChapter, typeOfContent, codeFeatureFilm} = data
			let conditionalType = typeOfContent == 'Largometrajes' || typeOfContent == 'LARGOMETRAJES' ? true : false
			response = conditionalType && materialHasChapter == 'No'? true : false
			return response
		},
		getFormat (valor) {
			// console.log(valor, 'getFormat')
			if(valor === 'Cortesía' ) {
				return valor
			} else {
				return valor ? convertNumberFormatUsd(Number(valor)) : ''
			}
		},
		isHaveNote(data) {
			const {noteDay} = data
			let style = noteDay !== '' ? 'flex-content justify_around' : ''
			return style
		},
		textIsBig(data) {
			let size = String(data)
			let value = size.length >= 11 ? value = `text_ellipsis` : ''
			return value
		}
	},
	created () {
		this.getWeek(this.dateString)
		this.timeForDay = this.formatedArray()
	},
	destroyed () {
		window.removeEventListener('scroll', this.handleScroll);
	},
	watch: {
		orderByProgram(val) {
			if ( val !== [] ) {
				this.fillingGrid(this.orderByProgram)
			}
    	}
	},
}
</script>
<style scoped>
.grid-schedule.resize{
	resize: vertical;
	overflow: auto;
}
.grid-schedule.resize.o-hidden{overflow: hidden;display:flex;justify-content: center}
.border-none{border:none}
</style>